Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Swing 1.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.swing.text
Class PlainDocument

    java.lang.Object
      |
      +--javax.swing.text.AbstractDocument
            |
            +--javax.swing.text.PlainDocument

public class PlainDocument
extends AbstractDocument

A plain document that maintains no character attributes. The default element structure for this document is a map of the lines in the text. The Element returned by getDefaultRootElement is a map of the lines, and each child element represents a line. This model does not maintain any character level attributes, but each line can be tagged with an arbitrary set of attributes. Line to offset, and offset to line translations can be quickly performed using the default root element. The structure information of the DocumentEvent's fired by edits will indicate the line structure changes.

The default content storage management is performed by a gapped buffer implementation (GapContent). It supports editing reasonably large documents with good efficiency when the edits are contiguous or clustered, as is typical.

Warning: Serialized objects of this class will not be compatible with future Swing releases. The current serialization support is appropriate for short term storage or RMI between applications running the same version of Swing. A future release of Swing will provide support for long term persistence.

See Also:
  `Document`, `AbstractDocument`, Serialized Form

Inner classes inherited from class javax.swing.text.AbstractDocument
`AbstractDocument.AbstractElement, AbstractDocument.AttributeContext, AbstractDocument.BranchElement, AbstractDocument.Content, AbstractDocument.DefaultDocumentEvent, AbstractDocument.ElementEdit, AbstractDocument.LeafElement`

Field Summary
`static java.lang.String` | `lineLimitAttribute` Name of the attribute that specifies the maximum length of a line, if there is a maximum length.
`static java.lang.String` | `tabSizeAttribute` Name of the attribute that specifies the tab size for tabs contained in the content.

Fields inherited from class javax.swing.text.AbstractDocument
`BAD_LOCATION, BidiElementName, ContentElementName, ElementNameAttribute, listenerList, ParagraphElementName, SectionElementName`

Constructor Summary
`` | `PlainDocument()` Constructs a plain text document.
`protected` | `PlainDocument(AbstractDocument.Content c)` Constructs a plain text document.

Method Summary
`protected AbstractDocument.AbstractElement` | `createDefaultRoot()` Creates the root element to be used to represent the default document structure.
`Element` | `getDefaultRootElement()` Gets the default root element for the document model.
`Element` | `getParagraphElement(int pos)` Get the paragraph element containing the given position.
`protected void` | `insertUpdate(AbstractDocument.DefaultDocumentEvent chng, AttributeSet attr)` Updates document structure as a result of text insertion.
`protected void` | `removeUpdate(AbstractDocument.DefaultDocumentEvent chng)` Updates any document structure as a result of text removal.

Methods inherited from class javax.swing.text.AbstractDocument
`addDocumentListener, addUndoableEditListener, createBranchElement, createLeafElement, createPosition, dump, fireChangedUpdate, fireInsertUpdate, fireRemoveUpdate, fireUndoableEditUpdate, getAsynchronousLoadPriority, getAttributeContext, getBidiRootElement, getContent, getCurrentWriter, getDocumentProperties, getEndPosition, getLength, getProperty, getRootElements, getStartPosition, getText, getText, insertString, postRemoveUpdate, putProperty, readLock, readUnlock, remove, removeDocumentListener, removeUndoableEditListener, render, setAsynchronousLoadPriority, setDocumentProperties, writeLock, writeUnlock`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### tabSizeAttribute

    public static final java.lang.String tabSizeAttribute

  Name of the attribute that specifies the tab size for tabs contained in the content. The type for the value is Integer.

### lineLimitAttribute

    public static final java.lang.String lineLimitAttribute

  Name of the attribute that specifies the maximum length of a line, if there is a maximum length. The type for the value is Integer.

Constructor Detail

### PlainDocument

    public PlainDocument()

  Constructs a plain text document. A default model using StringContent is constructed and set.

### PlainDocument

    protected PlainDocument(AbstractDocument.Content c)

  Constructs a plain text document. A default root element is created, and the tab size set to 8.
  Parameters:
    `c` - the container for the content

Method Detail

### getDefaultRootElement

    public Element getDefaultRootElement()

  Gets the default root element for the document model.
  Returns:
    the root
  Overrides:
    getDefaultRootElement in class AbstractDocument
  See Also:
    `Document.getDefaultRootElement()`

### createDefaultRoot

    protected AbstractDocument.AbstractElement createDefaultRoot()

  Creates the root element to be used to represent the default document structure.
  Returns:
    the element base

### getParagraphElement

    public Element getParagraphElement(int pos)

  Get the paragraph element containing the given position. Since this document only models lines, it returns the line instead.
  Overrides:
    getParagraphElement in class AbstractDocument

### insertUpdate

    protected void insertUpdate(AbstractDocument.DefaultDocumentEvent chng,
                                AttributeSet attr)

  Updates document structure as a result of text insertion. This will happen within a write lock. Since this document simply maps out lines, we refresh the line map.
  Parameters:
    `chng` - the change event describing the dit
    `attr` - the set of attributes for the inserted text
  Overrides:
    insertUpdate in class AbstractDocument

### removeUpdate

    protected void removeUpdate(AbstractDocument.DefaultDocumentEvent chng)

  Updates any document structure as a result of text removal. This will happen within a write lock. Since the structure represents a line map, this just checks to see if the removal spans lines. If it does, the two lines outside of the removal area are joined together.
  Parameters:
    `chng` - the change event describing the edit
  Overrides:
    removeUpdate in class AbstractDocument

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Swing 1.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
Java is a trademark or registered trademark of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-1998 Sun Microsystems, Inc. 901 San Antonio Road,
Palo Alto, California, 94303, U.S.A. All Rights Reserved.